function beforeDrawChart(dom, domAttr, domClass, domConstruct, domStyle, query, registry, request) {
  var chartContainer = query("div.display_chart")[0];
  var form = dom.byId("conditionTestChartGridCp");
  if (!chartContainer || !form) {
    return;
  }
  domConstruct.place(chartContainer, form, "after");
}

function drawChart() {
  require(["dojo/dom", "dojo/dom-attr", "dojo/dom-class", "dojo/dom-construct", "dojo/dom-style", "dojo/query", "dijit/form/Button", "dijit/registry", "dojo/request"],
  function(dom, domAttr, domClass, domConstruct, domStyle, query, Button, registry, request) {
    beforeDrawChart(dom, domAttr, domClass, domConstruct, domStyle, query, Button, registry, request);

    var chartContainer = query("div.display_chart")[0];
    hideChart();
    var charts = [];

    function showChart(grid) {
      var total = grid.get("total");
      var display = "none";
      if (total > 0) {
        display = "block";
      }
      domStyle.set(chartContainer, "display", display);
      if (display === "block") {
        for (var i=0,l=charts.length; i<l; i++) {
          charts[i].destroy();
        }
        charts = [];
        getChartData(function(data) {
          charts.push(createPowerConsumptionChart(data, dom, domAttr, domClass, domConstruct, domStyle, query, Button, registry, request, afterCreatePowerConsumptionChart));
          charts.push(createItem1Chart(data, dom, domAttr, domClass, domConstruct, domStyle, query, Button, registry, request, afterCreateItem1Chart));
          afterDrawAllChart(charts, dom, domAttr, domClass, domConstruct, domStyle, query, Button, registry, request);
        });
      }
    }

    function hideChart() {
      domStyle.set(chartContainer, "display", "none");
    }

    setTimeout(function() {
      var grid = window.getTestChartGridShowListGrid();
      if (grid) {
        grid.grid.on('dgrid-refresh-complete', function(e) {
          showChart(e.grid);
        });
      }
    }, 10);

  });
}

function getPowerConsumptionPowerConsumptionChartDataset(data) {
  return {
    yAxisID: "yAxis-left",
    type: "bar",
    label: getPowerConsumptionPowerConsumptionChartDatasetLabel(),
    data: getEntityListData(data.entity, 'powerConsumption'),
    backgroundColor: getPowerConsumptionPowerConsumptionChartDatasetBgColor(),
    borderColor: getPowerConsumptionPowerConsumptionChartDatasetBorderColor(),
    borderWidth: getChartBorderWidth(),
  };
}

function getPowerConsumptionPowerConsumptionChartDatasetLabel() {
  return "電力量";
}

function getPowerConsumptionTempChartDataset(data) {
  return {
    yAxisID: "yAxis-right",
    type: "line",
    label: getPowerConsumptionTempChartDatasetLabel(),
    data: getEntityListData(data.entity, 'temp'),
    backgroundColor: getPowerConsumptionTempChartDatasetBgColor(),
    borderColor: getPowerConsumptionTempChartDatasetBorderColor(),
    borderWidth: getChartBorderWidth(),
    fill: false,
  };
}

function getPowerConsumptionTempChartDatasetLabel() {
  return "気温";
}

function getPowerConsumptionTempChartDatasetColor() {
  return "orange";
}

function getPowerConsumptionTempChartDatasetBgColor() {
  return Chart.helpers.color(getPowerConsumptionTempChartDatasetColor()).alpha(getChartColorAlpha()).rgbString();
}

function getPowerConsumptionTempChartDatasetBorderColor() {
  return getPowerConsumptionTempChartDatasetColor();
}

function getPowerConsumptionChartDatasets(data) {
  var datasets = [];
  datasets.push(getPowerConsumptionPowerConsumptionChartDataset(data));
  datasets.push(getPowerConsumptionTempChartDataset(data));
  return datasets;
}

function getPowerConsumptionChartOptions(defaultChartOption) {
  var option = defaultChartOption;
  option.scales.xAxes[0].scaleLabel.labelString = "月";
  option.scales.yAxes[0].id = "yAxis-left";
  option.scales.yAxes[0].position = "left";
  option.scales.yAxes[0].scaleLabel.labelString = "電力量(千kWh)";
  option.scales.yAxes[0].ticks = {
    beginAtZero: true,
    maxTicksLimit: 6,
  };
  option.scales.yAxes[1] = {
    id: "yAxis-right",
    position: "right",
    scaleLabel: {
      display: true,
      labelString: "気温(℃)",
    },
    ticks: {
      beginAtZero: true,
      max: 35,
      min: 0,
    },
  };
  return option;
}

function getItem1ChartOptions(defaultChartOption) {
  var option = defaultChartOption;
  option.legend = {
    display: false,
  }
  option.scales.xAxes[0].scaleLabel.labelString = "月別平均気温(℃)";
  option.scales.yAxes[0].scaleLabel.labelString = "販売電力量(千kWh)";
  return option;
}

function getItem1Item1ChartDataset(data) {
  return {
    label: getItem1Item1ChartDatasetLabel(),
    data: getScatterData(data.entity, "temp", "powerConsumption"),
    backgroundColor: getItem1Item1ChartDatasetBgColor(),
    borderColor: getItem1Item1ChartDatasetBorderColor(),
    borderWidth: getChartBorderWidth(),
  };
}
